<?php
	
	class FunctionsMybb
	{
		public static function random_str($length = "8")
		{
			$set = array("a","A","b","B","c","C","d","D","e","E","f","F","g","G","h","H","i","I","j","J","k","K","l","L","m","M","n","N","o","O","p","P","q","Q","r","R","s","S","t","T","u","U","v","V","w","W","x","X","y","Y","z","Z","1","2","3","4","5","6","7","8","9");
			$str = '';

			for($i = 1; $i <= $length; ++$i)
			{
				$ch = self::my_rand(0, count($set)-1);
				$str .= $set[$ch];
			}

			return $str;
		}
		
		public static function generate_loginkey()
		{
			return self::random_str(50);
		}
		
		protected static function my_rand($min=null, $max=null, $force_seed=false)
		{
			static $seeded = false;
			static $obfuscator = 0;

			if($seeded == false || $force_seed == true)
			{
				mt_srand(self::secure_seed_rng());
				$seeded = true;

				$obfuscator = abs((int) self::secure_seed_rng());
				
				// Ensure that $obfuscator is <= mt_getrandmax() for 64 bit systems.
				if($obfuscator > mt_getrandmax())
				{
					$obfuscator -= mt_getrandmax();
				}
			}

			if($min !== null && $max !== null)
			{
				$distance = $max - $min;
				if ($distance > 0)
				{
					return $min + (int)((float)($distance + 1) * (float)(mt_rand() ^ $obfuscator) / (mt_getrandmax() + 1));
				}
				else
				{
					return mt_rand($min, $max);
				}
			}
			else
			{
				$val = mt_rand() ^ $obfuscator;
				return $val;
			}
		}
		
		protected static function secure_seed_rng($count=8)
		{
			$output = '';
			
			// Try the unix/linux method
			if(@is_readable('/dev/urandom') && ($handle = @fopen('/dev/urandom', 'rb')))
			{
				$output = @fread($handle, $count);
				@fclose($handle);
			}
			
			// Didn't work? Do we still not have enough bytes? Use our own (less secure) rng generator
			if(strlen($output) < $count)
			{
				$output = '';
				
				// Close to what PHP basically uses internally to seed, but not quite.
				$unique_state = microtime().@getmypid();
				
				for($i = 0; $i < $count; $i += 16)
				{
					$unique_state = md5(microtime().$unique_state);
					$output .= pack('H*', md5($unique_state));
				}
			}
			
			// /dev/urandom and openssl will always be twice as long as $count. base64_encode will roughly take up 33% more space but crc32 will put it to 32 characters
			$output = hexdec(substr(dechex(crc32(base64_encode($output))), 0, $count));
			
			return $output;
		}
	}
?>