<?php

	require ROOT_PATH . 'includes/classes/functions_mybb_class.php';
	
	class IntegratorMybb
		extends PDO
	{
		protected static $_singleton = NULL;
		protected static $_prefix = NULL;
		
		public static function getSingleton()
		{
			if (self::$_singleton === null)
			{
				$ds = DIRECTORY_SEPARATOR;
				
				try
				{
					require dirname(ROOT_PATH) . $ds . "forum{$ds}inc{$ds}config.php";
				}
				catch(Exception $e)
				{
					return array(
						'error'		=> true,
						'message'	=> "Impossible de lire la configuration du fichier du forum MyBB"
					);
				}
				
				$hostname = $config['database']['hostname'];
				$username = $config['database']['username'];
				$password = $config['database']['password'];
				$database = $config['database']['database'];
				
				try
				{
					self::$_singleton = new self("mysql:dbname={$database};host={$hostname}", $username, $password, array(
						PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION
					));
				}
				catch(Exception $e)
				{
					return array(
						'error'		=> true,
						'message'	=> "Echec de la connexion &agrave; la base de donn&eacute;es du forum"
					);
				}
			}
			
			self::$_prefix = $config['database']['table_prefix'];
			
			return self::$_singleton;
		}
		
		public static function CreateUser($Username, $Password, $Email)
		{
			$database = self::getSingleton();
			
			$Fields = NULL;
			
			$salt = FunctionsMybb::random_str();
			$saltedpw = md5(md5($salt).md5($Password));
			$loginkey = FunctionsMybb::generate_loginkey();
			$now = time();
			
			$newuser = array(
				'username' => $Username,
				'password' => $saltedpw,
				'salt' => $salt,
				'loginkey' => $loginkey,
				'email' => $Email,
				'usergroup' => 2, // assigned above
				'regdate' => $now,
				'lastactive' => $now,
				'lastvisit' => $now,
				'website' => '',
				'icq' => '',
				'aim' => '',
				'yahoo' => '',
				'msn' =>'',
				'birthday' => '',
				'signature' => '',
				'allownotices' => 1,
				'hideemail' => 0,
				'subscriptionmethod' => '0',
				'receivepms' => 1,
				'pmnotice' => 1,
				'pmnotify' => 1,
				'showsigs' => 1,
				'showavatars' => 1,
				'showquickreply' => 1,
				'invisible' => 0,
				'style' => '0',
				'timezone' => 0,
				'dst' => 0,
				'threadmode' => '',
				'daysprune' => 0,
				'regip' => $_SERVER['REMOTE_ADDR'],
				'language' => '',
				'showcodebuttons' => 1,
				'tpp' => 0,
				'ppp' => 0,
				'referrer' => 0,
				'buddylist' => '',
				'ignorelist' => '',
				'pmfolders' => '',
				'notepad' => '',
				'showredirect' => 1,
				'usernotes' => ''
			);
	
			foreach($newuser as $field => $value)
				$Fields[] = "`{$field}` = {$database->quote($value)}";
			
			$Fields = implode(", ", $Fields);
				
			$Table = self::$_prefix . 'users';
			
			$query = <<<SQL
INSERT INTO {$Table} 
SET 		{$Fields}
SQL;
			try
			{
				self::$_singleton->exec($query);
			}
			catch(PDOException $e)
			{
				return array(
					'error' 	=> 	true,
					'message'	=>	$e->getMessage()
				);
			}
			
			return array(
				'error'	=> false
			);
		}
	}